import alpenglow.Getter as rs
import alpenglow as prs


class TransitionProbabilityExperiment(prs.OnlineExperiment):
    def config(self, elems):
        config = self.parameter_defaults(
            top_k=100,
            min_time=0,
            seed=67439852,
            out_file=None,
            filters=[],
            loggers=[],
        )

        model = rs.TransitionProbabilityModel()
        updater = rs.TransitionProbabilityModelUpdater(**self.parameter_defaults(
          filter_freq_updates=False,
          mode_="normal",
          label_transition_mode_=False,
          label_file_name_=""
        ))
        updater.set_model(model)

        model = model
        learner = [updater]
        filters = [model]

        return {
            'config': config,
            'model': model,
            'learner': learner,
            'filters': filters,
        }
